#include "flash.h"
#include "stm32f10x.h"

#if FLASH_SIZE<256
#define SECTOR_SIZE 1024 //ֽ
#else 
#define SECTOR_SIZE	2048
#endif		 
uint16_t FLASH_BUF[SECTOR_SIZE/2];//2Kֽ

//ȡַָİ(16λ)
//faddr:ַ(˵ַΪ2ı!!)
//ֵ:Ӧ.
uint16_t FLASH_ReadHalfWord(uint32_t faddr)
{
	return *(uint16_t*)faddr; 
}


//д
//WriteAddr:ʼַ
//pBuffer:ָ
//NumToWrite:(16λ)   
void FLASH_Write_NoCheck(uint32_t WriteAddr,uint16_t *pBuffer,uint16_t NumToWrite)   
{ 			 		 
	uint16_t i;
	for(i=0;i<NumToWrite;i++)
	{
		FLASH_ProgramHalfWord(WriteAddr,pBuffer[i]);
		WriteAddr+=2;//ַ2.
	}  
} 

//ַָʼдָȵ
//WriteAddr:ʼַ(˵ַΪ2ı!!)
//pBuffer:ָ
//NumToWrite:(16λ)(Ҫд16λݵĸ.)
void FLASH_Write(uint32_t WriteAddr,uint16_t *pBuffer,uint16_t NumToWrite)	
{
	uint32_t secpos;	   //ַ
	uint16_t secoff;	   //ƫƵַ(16λּ)
	uint16_t secremain; //ʣַ(16λּ)	   
	uint16_t i;    
	uint32_t offaddr;   //ȥ0X08000000ĵַ
	
	if(WriteAddr<FLASH_BASE||(WriteAddr>=(FLASH_BASE+1024*FLASH_SIZE)))
		return;		//Ƿַ
	FLASH_Unlock();						//
	offaddr=WriteAddr-FLASH_BASE;		//ʵƫƵַ.
	secpos=offaddr/SECTOR_SIZE;			//ַ  0~512
	secoff=(offaddr%SECTOR_SIZE)/2;		//ڵƫ(2ֽΪλ.)
	secremain=SECTOR_SIZE/2-secoff;		//ʣռС   
	if(NumToWrite<=secremain)
		secremain=NumToWrite;//ڸΧ
	while(1) 
	{
		FLASH_Read(secpos*SECTOR_SIZE+FLASH_BASE,FLASH_BUF,SECTOR_SIZE/2);//
		for(i=0;i<secremain;i++)//У
		{
			if(FLASH_BUF[secoff+i]!=0XFFFF)
				break;//Ҫ
		}
		if(i<secremain)//Ҫ
		{
			FLASH_ErasePage(secpos*SECTOR_SIZE+FLASH_BASE);//
			for(i=0;i<secremain;i++)//
			{
				FLASH_BUF[i+secoff]=pBuffer[i];	  
			}
			FLASH_Write_NoCheck(secpos*SECTOR_SIZE+FLASH_BASE,FLASH_BUF,SECTOR_SIZE/2);//д  
		}
		else
		{
			FLASH_Write_NoCheck(WriteAddr,pBuffer,secremain);//дѾ˵,ֱдʣ. 		
		}
		if(NumToWrite==secremain)
			break;//д
		else//дδ
		{
			secpos++;				//ַ1
			secoff=0;				//ƫλΪ0 	 
			pBuffer+=secremain;  	//ָƫ
			WriteAddr+=(secremain*2);	//дַƫ	   
			NumToWrite-=secremain;	//ֽ(16λ)ݼ
			if(NumToWrite>(SECTOR_SIZE/2))
				secremain=SECTOR_SIZE/2;//һд
			else 
				secremain=NumToWrite;//һд
		}
	}
	FLASH_Lock();//
}

//ַָʼָȵ
//ReadAddr:ʼַ
//pBuffer:ָ
//NumToWrite:(16λ)
void FLASH_Read(uint32_t ReadAddr,uint16_t *pBuffer,uint16_t NumToRead)   	
{
	uint16_t i;
	
	for(i=0;i<NumToRead;i++)
	{
		pBuffer[i]=FLASH_ReadHalfWord(ReadAddr);//ȡ2ֽ.
		ReadAddr+=2;//ƫ2ֽ.	
	}
}

void FLASH_Write_2KB(uint32_t WriteAddr, uint8_t *pBuffer) 
{
	u16 i, WriteData;	
	INTX_DISABLE();
	FLASH_Unlock();
	FLASH_ErasePage(WriteAddr);
 if(FLASH_SIZE<0x100) //1KB/P
	  FLASH_ErasePage(WriteAddr+1024);
	for(i=0; i<2048; i+=2)
	{
		WriteData = (pBuffer[i+1]<<8) + pBuffer[i];
		FLASH_ProgramHalfWord(WriteAddr, WriteData);
		WriteAddr+=2;
	}
	
	FLASH_Lock();
    INTX_ENABLE();
}

